<?php
include "smilepay_respond.php";
/**
 * Plugin Name: SmilePay_C2C 
 * Plugin URI: http://www.smilepay.net
 * Description: SmilePay C2C 
 * Author:  SmilePay
 * Author URI: http://www.smilepay.net
 * Version: 2.2.4
 */
add_action('plugins_loaded', 'SmilePayc2c_gateway_init', 0);
function SmilePayc2c_gateway_init() {
   if (!class_exists('WC_Payment_Gateway')) {
        return;
    }
    class WC_SmilePayc2c extends WC_Payment_Gateway {
        public function __construct() {
            $this->id = 'SmilePayc2c';
            $this->icon = apply_filters('woocommerce_SmilePayc2c_icon', plugins_url('log/smilepay.jpg', __FILE__));
            $this->has_fields = false;
            $this->method_title = __('SmilePayc2c', 'woocommerce');
            // Load the form fields.
            $this->init_form_fields();
            // Load the settings.
            $this->init_settings();
			
            // Define user set variables
            $this->title = $this->settings['title'];
            $this->description = $this->settings['description'];
            $this->dcvc = $this->settings['dcvc'];
            $this->order_name = $this->settings['order_name'];
			$this->Order_OKmain = $this->settings['Order_OKmain'];
			$this->reurl = $this->settings['reurl'];
            // Actions
            //add_action('init', array(&$this, 'check_SmilePayc2c_response'));
            add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );
            add_action('woocommerce_thankyou_SmilePayc2c', array($this, 'thankyou_page')); 
        }
        /**
         * Initialise Gateway Settings Form Fields
         *
         * @access public
         * @return void
         */
        public function init_form_fields() {  //x]m
			$urll=get_option('siteurl')."/?respond";
            $this->form_fields = array(
                'enabled' => array(
                    'title' => __(u2b2("ҥ/"), 'woocommerce'),
                    'type' => 'checkbox',
                    'label' => __(u2b2(' SmilePay WӨfI'), 'woocommerce'),
                    'default' => 'yes'
                ),
                'title' => array(
                    'title' => __(u2b2('D'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2b2('UȦbbɩܪIڤ覡D'), 'woocommerce'),
                    'default' => __(u2b2('SmilePay WӨfI úO'), 'woocommerce')
                ),
                'description' => array(
                    'title' => __(u2b2('ȤT'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2b2('UȦbܥIڤ覡ɩܪФr'), 'woocommerce'),
                    'default' => __(u2b2("SmilePay  WӨfI úO"), 'woocommerce')
                ),
                'dcvc' => array(
                    'title' => __(u2b2('өN'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2b2('жJzSmilePayөN'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
                'order_name' => array(
                    'title' => __(u2b2('Hfӫ~W'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2b2("ͱHfɪӫ~W١A̦h20ӤrAL]wɫhaJ<font color='red'>W</font>"), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),	
                'Mid_smilepay' => array(
                    'title' => __(u2b2('ҽX'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2b2('жJzSmilePaҽXAҽXӮaxu򥻸ƺ޲zvAнƻsöKJWApҽЫOdť'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),				
				'Order_OKmain' => array(
                    'title' => __(u2b2('q榨߫ܰT'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2b2('q榨ܰT'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
				'reurl' => array(
                    'title' => __(u2b2('^em'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2b2('^emAбNUCrƻsWؤ(p^eЯdť)</br><font color=red ue size=+1>'.$urll.'</font>', 'woocommerce')),
                    'default' => __('', 'woocommerce')
                ),
				'hiddtext' => array(
                    'title' => __(u2b2('WӨfIڪ`Nƶ'), 'woocommerce'),
                    'type' => 'hidden',
                    'description' => __(u2b2("ϥζWӨfIڥ\Aݪ`NHUƶG
												<br>1.ХSmilePayӮax}ҨfIڥ\*<a target='_blank' href='http://www.smilepay.net/RVG.ASP'>Ӯax</a>*
												<br>2.*Hfӫ~W*qW١AëDӫ~ӡA]qW<font color='red'>Lе</font>C
												<br>3.bT<font color='red'>pq</font><font color='red'>X</font>Aӫ~ɷ|H²TqC
												<br>4.O̦߭qAЦSmilePayӮaxo<font color='red'>fKNX</font>C
												<br>5.бN<font color='red'>fKNX</font>ʷsWܰӫ~ƵAHQO̬dߪyAC
												<br>6.hаѾ\A<font color='red'>SmilePay</font>P<font color='red'>WooCommerceҲջ</font>C
												"), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),            
			);
        }
        /**
         * Admin Panel Options
         * - Options for bits like 'title' and availability on a country-by-country basis
         *
         * @access public
         * @return void
         */
       public function get_SmilePayc2c_args($order) {
            global $woocommerce;

            $paymethod = 'c2c';
            $order_id = $order->id;
			$post_status = $order->post_status;


            $SmilePayc2c_args = array(
                "dcvc" => $this->dcvc,
				"dcvg" => $this->dcvg,
                "payment_type" => $paymethod,
                "od_sob" => $order_id,
				"post_status" => $post_status,
				"order_name" => $order_name,
				'Order_OKmain' => $this->Order_OKmain,
				'reurl' => $this->reurl,
				"amt" => round($order->get_order_total()),
            );
            $SmilePayc2c_args = apply_filters('woocommerce_SmilePayc2c_args', $SmilePayc2c_args);
            return $SmilePayc2c_args;
        }
		
       public function thankyou_page($order_id) {  //^ǰѼ  P   c2c
			global $post, $wpdb, $thepostid, $theorder, $order_status, $woocommerce;
			$order = &new WC_Order($order_id);

			$SmilePayc2c_args = $this->get_SmilePayc2c_args($order);
			$order_status=$SmilePayc2c_args['post_status'];

		if($order_status=='wc-pending')
		{	
			//P_qܬO_T,mW
			if(substr($order->billing_phone,0,2)!="09"||mb_strlen($order->billing_phone)!=10){
				$order->update_status('cancelled');
				echo u2b2("<font color=red>q榨ߥ</font><br><br>~TG<br>sqܽпJ(@10X)Aӫ~쩱ANoe²TqC<br>WrPm`XiWL5ӦrC<br><br>ЭsbC");
				addtocart($thepostid);
				exit();
			}	
			if(mb_strlen($order->billing_first_name.$order->billing_last_name)>5){
				$order->update_status('cancelled');
				echo u2b2("<font color=red>q榨ߥ</font><br><br>~TG<br>sqܽпJ(@10X)Aӫ~쩱ANoe²TqC<br>WrPm`XiWL5ӦrC<br><br>ЭsbC");
				addtocart($thepostid);
				exit();
			}
			
				
			//}C2C
			if($SmilePayc2c_args['reurl']!=''){$Vk=$SmilePayc2c_args['reurl']."=".$order->order_key;}else{$Vk='';}
			if($SmilePayc2c_args['order_name']==''){$order_name=get_option('blogname');}else{$order_name=$SmilePayc2c_args['order_name'];}
			$URL = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
			$cardurl =	'https://ssl.smse.com.tw/ezpos/mtmk_utf.asp?'.
						'Dcvc=' . $SmilePayc2c_args['dcvc'] .
						'&Pay_zg=41' .
						'&Rvg2c=1' .
						'&Od_sob=' .$SmilePayc2c_args['od_sob'].
						'&Pur_name=' .$order->billing_first_name.$order->billing_last_name.
						'&Mobile_number=' .$order->billing_phone.
						'&Email=' .$order->billing_email.
						'&Data_id=' . $SmilePayc2c_args['od_sob'].
						'&Amount=' . $SmilePayc2c_args['amt'].
						'&Roturl_status=' . 'woook'.
						'&Roturl=' . $Vk.
						'&MapRoturl=' . urlencode($URL).
						'&Remark=woocommerce';
			//qܦѤ			
			$order->update_status('on-hold');			
			header("Location: $cardurl"); 
			exit();	
		}		
		if($order_status=='wc-on-hold'&&$_REQUEST['Classif']=='T')
		{
			$T_Smseid=$_REQUEST['Smseid'];
			$T_Storename=b2u2($_REQUEST['Storename']);
			$T_Storeid=b2u2($_REQUEST['Storeid']);
			$pay_ok="úO覡G<font color=red>WӨfI</font><br>GG<font color=red>q榨ߦ\</font><br>fG<font color=red>".$T_Storename.$T_Storeid."</font>";
			$order->add_order_note(u2b2($pay_ok),"1");
			$ordertext="ФŧRTG".$T_Smseid;
			$order->add_order_note(u2b2($ordertext),"0");
			echo u2b2("<font color='red' size='3'>`NGqwߡAݰӮaHfAӫ~FN|H²TqIڨf</font><br><br>");
			echo u2b2($pay_ok);
			echo "<br><br>".$SmilePayc2c_args['Order_OKmain'];
		}
}
        /**
         * Process the payment and return the result
         *
         * @access public
         * @param int $order_id
         * @return array
         */
        public function process_payment($order_id) {
		$order = new WC_Order( $order_id );

		// Mark as on-hold (we're awaiting the cheque)
		// Reduce stock levels
		$order->reduce_order_stock();

		// Remove cart
		//WC()->cart->empty_cart();


		// Return thankyou redirect
		return array(
			'result' 	=> 'success',
			'redirect'	=> $this->get_return_url( $order )
		);
        }

        /**
         * Payment form on checkout page
         *
         * @access public
         * @return void
         */
    }
    /**
     * Add the gateway to WooCommerce
     *
     * @access public
     * @param array $methods
     * @package		WooCommerce/Classes/Payment
     * @return array
     */
    function add_SmilePayc2c_gateway($methods) {
        $methods[] = 'WC_SmilePayc2c';
        return $methods;
    }

    add_filter('woocommerce_payment_gateways', 'add_SmilePayc2c_gateway');
}
function u2b2($text)//eX
{	return iconv("big5","UTF-8",$text);}
function b2u2($text)//gJƮw
{	return iconv("UTF-8","big5",$text);}
function addtocart($thepostid)
{
global $post, $wpdb, $thepostid, $theorder, $order_status, $woocommerce;
$sqlll="SHOW TABLES LIKE  '%comments%'";
$recheck=mysql_query($sqlll);
$row = mysql_fetch_array($recheck);
$tablelist=$row[0];
$tablelist=explode('_',$tablelist);
$tablelist=$tablelist[0].'_';
//ӫ~q渹
$order_items = $wpdb->get_results( "SELECT * FROM `".$tablelist."woocommerce_order_items"."` WHERE `order_id` = '$thepostid' " );
	foreach ( $order_items as $order_no ) 
	{
		$vr =$order_no->order_item_id;
		//ӫ~ID,ƶq
		if($order_no->order_item_type=="line_item"){
			$order_itemmeta = $wpdb->get_results( "SELECT * FROM `".$tablelist."woocommerce_order_itemmeta"."` WHERE `order_item_id` = '$vr' "  );
			foreach ( $order_itemmeta as $order_id ) 
			{	
				if($order_id->meta_key=="_product_id"){$order_add_id=$order_id->meta_value;}
				if($order_id->meta_key=="_qty"){$order_add_num=$order_id->meta_value;}
			}
			WC()->cart->add_to_cart($order_add_id,$order_add_num);
		}
	}
}

?>