<?php
//include "smilepay_respond.php";
/**
 * Plugin Name: SmilePay_Credit 
 * Plugin URI: http://www.smilepay.net
 * Description: SmilePay Credit 
 * Author:  SmilePay
 * Author URI: http://www.smilepay.net
 * Version: 2.2.4
 */
add_action('plugins_loaded', 'SmilePaycredit_gateway_init', 0);
function SmilePaycredit_gateway_init() {
   if (!class_exists('WC_Payment_Gateway')) {
        return;
    }
    class WC_SmilePaycredit extends WC_Payment_Gateway {
        public function __construct() {
            $this->id = 'SmilePaycredit';
            $this->icon = apply_filters('woocommerce_SmilePaycredit_icon', plugins_url('log/paycredit.jpg', __FILE__));
            $this->has_fields = false;
            $this->method_title = __('SmilePaycredit', 'woocommerce');
            // Load the form fields.
            $this->init_form_fields();
            // Load the settings.
            $this->init_settings();
			
            // Define user set variables
            $this->title = $this->settings['title'];
            $this->description = $this->settings['description'];
            $this->dcvc = $this->settings['dcvc'];
			$this->Order_OKmain = $this->settings['Order_OKmain'];
            // Actions
            //add_action('init', array(&$this, 'check_SmilePaycredit_response'));
            add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );
            add_action('woocommerce_thankyou_SmilePaycredit', array($this, 'thankyou_page')); 
        }
        /**
         * Initialise Gateway Settings Form Fields
         *
         * @access public
         * @return void
         */
        public function init_form_fields() {  //x]m
            $this->form_fields = array(
                'enabled' => array(
                    'title' => __(u2bcr("ҥ/"), 'woocommerce'),
                    'type' => 'checkbox',
                    'label' => __(u2bcr(' SmilePay uWd'), 'woocommerce'),
                    'default' => 'yes'
                ),
                'title' => array(
                    'title' => __(u2bcr('D'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bcr('UȦbbɩܪIڤ覡D'), 'woocommerce'),
                    'default' => __(u2bcr('SmilePay uWd úO'), 'woocommerce')
                ),
                'description' => array(
                    'title' => __(u2bcr('ȤT'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2bcr('UȦbܥIڤ覡ɩܪФr'), 'woocommerce'),
                    'default' => __(u2bcr("SmilePay  uWd úO"), 'woocommerce')
                ),
                'dcvc' => array(
                    'title' => __(u2bcr('өN'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bcr('жJzSmilePayөN'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
				'Order_OKmain' => array(
                    'title' => __(u2bcr('q榨߫ܰT'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2bcr('q榨ܰT'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
            );
        }
        /**
         * Admin Panel Options
         * - Options for bits like 'title' and availability on a country-by-country basis
         *
         * @access public
         * @return void
         */
       public function get_SmilePaycredit_args($order) {
            global $woocommerce;

            $paymethod = 'credit';
            $order_id = $order->id;
			$post_status = $order->post_status;

            $SmilePaycredit_args = array(
                "dcvc" => $this->dcvc,
				"dcvg" => $this->dcvg,
                "payment_type" => $paymethod,
				"post_status" => $post_status,
                "od_sob" => $order_id,
				'Order_OKmain' => $this->Order_OKmain,
				"amt" => round($order->get_order_total()),
            );
            $SmilePaycredit_args = apply_filters('woocommerce_SmilePaycredit_args', $SmilePaycredit_args);
            return $SmilePaycredit_args;
        }
		
       public function thankyou_page($order_id) {  //^ǰѼ  P   credit
			global $post, $wpdb, $thepostid, $theorder, $order_status, $woocommerce;
			$order = &new WC_Order($order_id);
			
			$SmilePaycredit_args = $this->get_SmilePaycredit_args($order);
			$order_status=$SmilePaycredit_args['post_status'];
			
			
		if($order_status=='wc-pending'||$order_status=='wc-failed')
		{
			//qܦᵲ
			$order->update_status('on-hold');	
          	//}ҽuWd
			$URL = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
			$cardurl =	'https://ssl.smse.com.tw/ezpos/mtmk_utf.asp?'.
						'Dcvc=' . $SmilePaycredit_args['dcvc'] .
						'&Pay_zg=1' .
						'&Rvg2c=1' .
						'&Pur_name=' .$order->billing_first_name.$order->billing_last_name.
						'&Tel_number=' .$order->billing_phone.
						'&Address=' .$order->billing_address_1.
						'&Email=' .$order->billing_email.
						'&Data_id=' . $SmilePaycredit_args['od_sob'].
						'&od_sob=' . $SmilePaycredit_args['od_sob'].
						'&Amount=' . $SmilePaycredit_args['amt'].
						'&Deadline_date=' . $Deadline_date.
						'&Roturl_status=' . 'woook'.
						'&Roturl=' . urlencode($URL).
						'&Remark=woocommerce';
			header("Location: $cardurl"); 
			exit();	
		}		
		if($order_status=='wc-on-hold'&&$_REQUEST['Classif']=='A')
		{
			$A_Amount=$_REQUEST['Amount'];
			$A_Data_id=$_REQUEST['Data_id'];
			$A_Response_id=$_REQUEST['Response_id'];
			$A_Errdesc=$_REQUEST['Errdesc'];
			$A_Smseid=$_REQUEST['Smseid'];
			$A_date=$_REQUEST['Process_date'];
			$A_time=$_REQUEST['Process_time'];
			if($A_Response_id=='1'&&$SmilePaycredit_args['amt']==$A_Amount)
			{
				$pay_ok="úO覡G<font color=red>uWd</font><br>GG<font color=red>v\</font></br>vBG<font color=red>".
							$A_Amount."</font></br>ɶG<font color=red>".$A_date.$A_time."</font></br>";
				$order->add_order_note(u2bcr($pay_ok),"1");
				$ordertext="úO覡G<font color=red>uWd</font><br>GG<font color=red>v\</font></br>vBG<font color=red>".
							$A_Amount."</font></br>ɶG<font color=red>".$A_date.$A_time."</font></br>SmilePaylܽXG<font color=red>".$A_Smseid."</font>";
				$order->add_order_note(u2bcr($ordertext),"0");
				$order->update_status('processing');
				echo u2bcr($pay_ok);
			}
			else
			{
				$pay_err="úO覡G<font color=red>uWd</font><br>GG<font color=red>v</font></br>ɶG<font color=red>".
							$A_date.$A_time."</font></br>ѭ]G<font color=red>".$A_Errdesc."</font></br>";
				$order->add_order_note(u2bcr($pay_err),"1");
				$ordertext="úO覡G<font color=red>uWd</font><br>GG<font color=red>v</font></br>ɶG<font color=red>".
							$A_date.$A_time."</font></br>ѭ]G<font color=red>".$A_Errdesc."</font></br>SmilePaylܽXG<font color=red>".$A_Smseid."</font>";
				$order->add_order_note(u2bcr($ordertext),"0");
				$order->update_status('failed');
				echo u2bcr($pay_err);
			}
			echo "<br><br>".$SmilePaycredit_args['Order_OKmain'];
		}
}
        /**
         * Process the payment and return the result
         *
         * @access public
         * @param int $order_id
         * @return array
         */
        public function process_payment($order_id) {
		$order = new WC_Order( $order_id );

		// Mark as on-hold (we're awaiting the cheque)
		// Reduce stock levels
		$order->reduce_order_stock();

		// Remove cart
		WC()->cart->empty_cart();

		// Return thankyou redirect
		return array(
			'result' 	=> 'success',
			'redirect'	=> $this->get_return_url( $order )
		);
        }

        /**
         * Payment form on checkout page
         *
         * @access public
         * @return void
         */
    }
    /**
     * Add the gateway to WooCommerce
     *
     * @access public
     * @param array $methods
     * @package		WooCommerce/Classes/Payment
     * @return array
     */
    function add_SmilePaycredit_gateway($methods) {
        $methods[] = 'WC_SmilePaycredit';
        return $methods;
    }

    add_filter('woocommerce_payment_gateways', 'add_SmilePaycredit_gateway');
}
function u2bcr($text)//eX
{	return iconv("big5","UTF-8",$text);}
function b2ucr($text)//gJƮw
{	return iconv("UTF-8","big5",$text);}
?>